<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-button/paper-button.html">
<link rel="import" href="/extern/bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="/extern/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/extern/bower_components/paper-spinner/paper-spinner.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/ajaxell/html/elements/ajaxell-icons/ajaxell-icons.html">
<link rel="import" href="/extern/bower_components/iron-icon/iron-icon.html">
<link rel="import" href="/extern/bower_components/iron-icons/iron-icons.html">

<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">
<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/command-input/command-input.html">

<!--
`ts-operations` is the polymer element of the operations panel

Example:

    <ts-operations></ts-operations>

-->

<dom-module id="ts-operations">
  <template>
    <link rel="stylesheet" type="text/css" href="css/ts-operations-min.css?__inline=true">
    <style include="reset-css"></style>
    <style include="iron-flex-layout-attributes"></style>

    <section horizontal layout>
      <section inputs>
        <ts-ajax id="ajax_inputs" data="{{_inputs}}" callback="getInputs" handle-as="json" auto></ts-ajax>
        <template is="dom-repeat" items="{{_inputs}}" as="input" sort="_sortInput">
          <command-input name=[[input.name]] type=[[input.type]] value={{input.value}} always-float-label></command-input>
        </template>
      </section>
      <section flex>
        <section state>
          <p>
            <span status>[[_displayStatus]]</span>
            <template is="dom-if" if="[[_inTransition]]">
              <span>in progress</span>
            </template>
            <paper-icon-button icon="ajaxell:operations" on-click="_getSVG"></paper-icon-button>
            <paper-spinner active="[[_inTransition]]"></paper-spinner>
          </p>
          <ts-ajax id="ajax_svg" data="{{_svg}}" callback="getGraph" handle-as="text" interval="0"></ts-ajax>
          <paper-dialog id="svg">
          </paper-dialog>
        </section>
        <section commands>
          <template is="dom-repeat" items="[[commands]]" as="command">
            <paper-button raised on-click="_execute" command$="[[command]]">[[command]]</paper-button>
          </template>
          <paper-button raised on-click="_execute" command="reset">reset</paper-button>
          <ts-ajax id="ajax_commands" data="{{commands}}" callback="getCommands" handle-as="json"></ts-ajax>
        </section>

        <section results>
          <auto-update id="update_result"
                       data="{{_result}}"
                       callback="getResult"
                       handle-as="json"
                       interval="7000"
                       no-slider></auto-update>
          <ts-ajax id="ajax_status" data="{{_status}}" callback="getStatus" handle-as="text" on-response="_newStatus"></ts-ajax>
          <div id="result" flex></div>
        </section>
      </section>
    </section>

    <ts-ajax id="execute"
             callback="execute"
             handle-as="json"></ts-ajax>

  </template>
  <script src="javascript/ts-operations-min.js?__inline=true"></script>
</dom-module>
